#pragma once

#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cstdio>
#include <CGAL/basic.h>
#include <CGAL/Cartesian.h>		//Kernel
#include <CGAL/Polyhedron_3.h>	//Mesh
using namespace std;

////////////////////////////////////////////////////////////////////////////////
// Helpful for general purpose
typedef CGAL::Cartesian<double>									Kernel;
typedef Kernel::Vector_3										Vector;
typedef Kernel::Point_3											Point;
typedef CGAL::Polyhedron_3<Kernel>								Polyhedron;

typedef Polyhedron::Vertex										Vertex;
typedef Polyhedron::Halfedge_handle								Halfedge_handle;
typedef Polyhedron::Vertex_iterator								Vertex_iterator;
typedef Polyhedron::Edge_iterator								Edge_iterator;
typedef Polyhedron::Facet_iterator								Facet_iterator;
typedef Polyhedron::Halfedge_around_vertex_const_circulator		HV_circulator;
typedef Polyhedron::Halfedge_around_facet_circulator			HF_circulator;
typedef Polyhedron::HalfedgeDS									HalfedgeDS;